#ifndef EYES_ACTIONS_CALLBACK_FUNC_H
#define EYES_ACTIONS_CALLBACK_FUNC_H

#include <QObject>
#include <QElapsedTimer>
#include "vrpn_Button.h"
#include "ICommunicationGraphicalServer.h"

#ifndef _WIN32
# include "XAction.h"
#endif // !_WIN32

class MainController;

namespace eyetrack
{
	/**
	** \brief Callback class for EyeTracking Signals
	*/
	class eyes_actions_callback_func : public QObject
	{
	  //Q_OBJECT

	public:
		eyes_actions_callback_func(QObject* parent);
		~eyes_actions_callback_func();

	public slots:
		/**
		** \brief Actions to exec on direction changing
		*/
		void			Slt_LookLeft();
		void			Slt_LookRight();
		void			Slt_LookTop();
		void			Slt_LookBottom();
		void			Slt_LookUnknown();
		/**
		** \brief Actions to exec on blinking action
		*/
		void			Slt_BlinkLeft();
		void			Slt_BlinkRight();
		void			Slt_BlinkDouble();

	private:
		Qt::Key			mKey;
		MainController*	mMC;
		QElapsedTimer	mTimer;
		
		void			keyemul(const Qt::Key);
	};
}

#endif // !EYES_ACTIONS_CALLBACK_FUNC_H
