#include <QtGui>
#include "AddProfilWindow.h"

AddProfilWindow::AddProfilWindow(QWidget *parent = 0)
    : QDialog(parent)
{
    initWindow();
    createWindow();

    connect(_okButton, SIGNAL(clicked()),
		this, SLOT(accept()));
    connect(_cancelButton, SIGNAL(clicked()),
	    this, SLOT(reject()));

    connect(this->_addShortcut, SIGNAL(clicked()), this, SLOT(addShortcut()));
	connect(this->_removeShortcut, SIGNAL(clicked()), this, SLOT(removeShortcut()));

    setWindowTitle(tr("Ajouter un profil"));
}

AddProfilWindow::AddProfilWindow(const AddProfilWindow &pW)
{

}

AddProfilWindow::~AddProfilWindow()
{

}

void	AddProfilWindow::initWindow()
{
	// labels
	_actionLabel = new QLabel(tr("Action"));
	_keyLabel = new QLabel(tr("Touche clavier"));
	_nameLabel = new QLabel(tr("Nom"));
	_vrpnIpLabel = new QLabel(tr("IP du serveur vrpn"));
	// widgets
	_shortcutView = new QTableView;
	_okButton = new QPushButton(tr("Ok"));
	_cancelButton = new QPushButton(tr("Annuler"));
	_addShortcut = new QPushButton(tr("Ajouter"));
	_removeShortcut = new QPushButton(tr("Supprimer"));
	_profilName = new QLineEdit;
	_vrpnIp = new QLineEdit;
	_action = new QComboBox;
	_key = new KeyboardHandle();
	
	// settings
	_shortcutView->verticalHeader()->hide();
	_shortcutView->horizontalHeader()->hide();
	_shortcutView->setEditTriggers(0);
	_action->addItem(tr("Droite -- EEG"));
    _action->addItem(tr("Bas -- EEG"));
    _action->addItem(tr("Retour -- EEG"));
	_action->addItem(tr("Clignement droit -- Eye-Tracking"));
}

void				AddProfilWindow::createWindow()
{
	QGridLayout*	gLayout = new QGridLayout;
	QVBoxLayout*	mainLayout = new QVBoxLayout;
	QHBoxLayout*	buttonLayout = new QHBoxLayout;
	QHBoxLayout*	shortcutLayout = new QHBoxLayout;

	gLayout->setColumnStretch(1, 2);
	gLayout->addWidget(_nameLabel, 0, 0);
	gLayout->addWidget(_profilName, 0, 1);
	gLayout->addWidget(_shortcutView, 1, 1);
	gLayout->addWidget(_actionLabel, 2, 0);
	gLayout->addWidget(_action, 2, 1);
	gLayout->addWidget(_keyLabel, 3, 0);
	gLayout->addWidget(_key, 3, 1);
	shortcutLayout->addWidget(_addShortcut);
	shortcutLayout->addWidget(_removeShortcut);
	gLayout->addLayout(shortcutLayout, 4, 1);
	gLayout->addWidget(_vrpnIpLabel, 5, 0);
	gLayout->addWidget(_vrpnIp, 5, 1);
	gLayout->addLayout(shortcutLayout, 6, 1);
	buttonLayout->addWidget(_okButton);
	buttonLayout->addWidget(_cancelButton);
	gLayout->addLayout(buttonLayout, 7, 1, Qt::AlignRight);

	mainLayout->addLayout(gLayout);
	setLayout(mainLayout);
	this->_ShortcutModel = new QStandardItemModel(0, 2, this);
}

QStandardItemModel*	AddProfilWindow::getModel() const
{
	return (this->_ShortcutModel);
}

QTableView*	AddProfilWindow::getView() const
{
	return (this->_shortcutView);
}

void					AddProfilWindow::addShortcut()
{
	this->_shortcuts.insert(this->_key->key, this->_action->currentIndex());
	this->_ShortcutModel->insertRow(this->_ShortcutModel->rowCount(), this->_ShortcutModel->index(this->_shortcuts.size() - 1, 0));
	this->_ShortcutModel->setData(this->_ShortcutModel->index(this->_shortcuts.size() - 1, 0), this->_action->currentText(), Qt::DisplayRole);
	this->_ShortcutModel->setData(this->_ShortcutModel->index(this->_shortcuts.size() - 1, 1), this->_key->text(), Qt::DisplayRole);
	this->_shortcutView->setModel(this->_ShortcutModel);
}

void	AddProfilWindow::removeShortcut()
{
	this->_shortcuts.remove(this->_key->key);
	QItemSelection selection(this->_shortcutView->selectionModel()->selection());
	QList<int> rows;
	int prev = -1;

	foreach(const QModelIndex & index, selection.indexes())
		rows.append(index.row());
	qSort(rows);
	for(int i = rows.count() - 1; i >= 0; i--)
	{
		int current = rows[i];
		if (current != prev)
		{
			this->_ShortcutModel->removeRows( current, 1 );
			prev = current;
		}
	}
	this->_shortcutView->setModel(this->_ShortcutModel);
}